#ifndef SKIP32_H
#define SKIP32_H
/*
	Header file for the SKIP32 encryption algorithm
	See c file for the credits
	WARNING: only tested for little endian machines where unsigned long = 32
	
	key is 80 bit (10byte) key
	
*/
#include "Arduino.h"
#include "TRXtypes.h"

class skip32
{
  public:
	skip32();
	skip32(BYTE key[]);
	skip32(BYTE key[],int len);
	void set_key(BYTE key[]);
	void set_key(BYTE key[],int len);
	void encrypt32 (unsigned long *data);
	void decrypt32 (unsigned long *data);
	int autotest();
  private:
    BYTE key[10];
    void skip32raw(BYTE key[10], BYTE buf[4], int encrypt);
};

#endif 
